
kernel void reduce(global int* data) 
{
    uint id = get_global_id(0);
    uint blockSize = get_local_size(0);
    for(uint s = 1; s <= blockSize; s *= 2)
    {
        if(id <= blockSize-s)
        {
            data[2 * id * s] = data[2 * id * s] + data[s * 2 * id + s];
        }
        barrier(CLK_GLOBAL_MEM_FENCE);
    }
}

kernel void reduceInverse(global int* data) 
{
    uint id = get_global_id(0);
    uint blockSize = get_local_size(0);
    uint stride = 1;
    for(uint s = blockSize; s > 0; s >>= 1)
    {
        if(id < stride)
        {
            int il = 2 * id * s;
            int ir = il + s;
            
            int left = data[il];
            int right = data[ir];
                                
            data[ir] = left;
            
            data[il] = left + right;
        }
        stride *= 2;
        barrier(CLK_GLOBAL_MEM_FENCE);
    }
}

kernel void compact(global int* prefixSum, global int* result, global int* rayBool, global int* rayIndex)
{
    uint id = get_global_id(0);
    int exists = rayBool[id];
    if(exists)
    {
        result[prefixSum[id]] = rayIndex[id];
    }
}